/[gentoo-x86]/eclass/autotools.eclass
Gentoo

Diff of /eclass/autotools.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.99 Revision 1.127
1# Copyright 1999-2010 Gentoo Foundation 1# Copyright 1999-2012 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/autotools.eclass,v 1.99 2010/07/06 18:55:50 vapier Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/autotools.eclass,v 1.127 2012/03/21 17:12:01 flameeyes Exp $
4 4
5# @ECLASS: autotools.eclass 5# @ECLASS: autotools.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# base-system@gentoo.org 7# base-system@gentoo.org
8# @BLURB: Regenerates auto* build scripts 8# @BLURB: Regenerates auto* build scripts
9# @DESCRIPTION: 9# @DESCRIPTION:
10# This eclass is for safely handling autotooled software packages that need to 10# This eclass is for safely handling autotooled software packages that need to
11# regenerate their build scripts. All functions will abort in case of errors. 11# regenerate their build scripts. All functions will abort in case of errors.
12#
13# NB: If you add anything, please comment it!
14 12
13# Note: We require GNU m4, as does autoconf. So feel free to use any features
14# from the GNU version of m4 without worrying about other variants (i.e. BSD).
15
16if [[ ${___ECLASS_ONCE_AUTOTOOLS} != "recur -_+^+_- spank" ]] ; then
17___ECLASS_ONCE_AUTOTOOLS="recur -_+^+_- spank"
18
15inherit eutils libtool 19inherit eutils libtool versionator
16 20
17# @ECLASS-VARIABLE: WANT_AUTOCONF 21# @ECLASS-VARIABLE: WANT_AUTOCONF
18# @DESCRIPTION: 22# @DESCRIPTION:
19# The major version of autoconf your package needs 23# The major version of autoconf your package needs
20: ${WANT_AUTOCONF:=latest} 24: ${WANT_AUTOCONF:=latest}
22# @ECLASS-VARIABLE: WANT_AUTOMAKE 26# @ECLASS-VARIABLE: WANT_AUTOMAKE
23# @DESCRIPTION: 27# @DESCRIPTION:
24# The major version of automake your package needs 28# The major version of automake your package needs
25: ${WANT_AUTOMAKE:=latest} 29: ${WANT_AUTOMAKE:=latest}
26 30
31# @ECLASS-VARIABLE: WANT_LIBTOOL
32# @DESCRIPTION:
33# Do you want libtool? Valid values here are "latest" and "none".
34: ${WANT_LIBTOOL:=latest}
35
27# @ECLASS-VARIABLE: _LATEST_AUTOMAKE 36# @ECLASS-VARIABLE: _LATEST_AUTOMAKE
37# @INTERNAL
28# @DESCRIPTION: 38# @DESCRIPTION:
29# CONSTANT! 39# CONSTANT!
30# The latest major version/slot of automake available on each arch. 40# The latest major-minor version/slot of automake available on each arch. #312315
31# If a newer version is stable on any arch, and is NOT reflected in this list, 41# If a newer slot is stable on any arch, and is NOT reflected in this list,
32# then circular dependencies may arise during emerge @system bootstraps. 42# then circular dependencies may arise during emerge @system bootstraps.
33# Do NOT change this variable in your ebuilds! 43# Do NOT change this variable in your ebuilds!
34_LATEST_AUTOMAKE='1.11' 44_LATEST_AUTOMAKE=1.11.1
35 45
36_automake_atom="sys-devel/automake" 46_automake_atom="sys-devel/automake"
37_autoconf_atom="sys-devel/autoconf" 47_autoconf_atom="sys-devel/autoconf"
38if [[ -n ${WANT_AUTOMAKE} ]]; then 48if [[ -n ${WANT_AUTOMAKE} ]]; then
39 case ${WANT_AUTOMAKE} in 49 case ${WANT_AUTOMAKE} in
40 none) _automake_atom="" ;; # some packages don't require automake at all 50 none) _automake_atom="" ;; # some packages don't require automake at all
41 # if you change the "latest" version here, change also autotools_run_tool 51 # if you change the "latest" version here, change also autotools_run_tool
42 # this MUST reflect the latest stable major version for each arch! 52 # this MUST reflect the latest stable major version for each arch!
43 latest) _automake_atom="|| ( `printf '=sys-devel/automake-%s* ' ${_LATEST_AUTOMAKE}` )" ;; 53 latest)
54 if [[ ${EAPI:-0} != 0 ]]; then
55 _automake_atom=">=sys-devel/automake-${_LATEST_AUTOMAKE}:$(get_version_component_range 1-2 ${_LATEST_AUTOMAKE})"
56 else
57 _automake_atom=">=sys-devel/automake-${_LATEST_AUTOMAKE} =sys-devel/automake-$(get_version_component_range 1-2 ${_LATEST_AUTOMAKE})*"
58 fi
59 ;;
60 *)
44 *) _automake_atom="=sys-devel/automake-${WANT_AUTOMAKE}*" ;; 61 _automake_atom="=sys-devel/automake-${WANT_AUTOMAKE}*" ;;
45 esac 62 esac
46 export WANT_AUTOMAKE 63 export WANT_AUTOMAKE
47fi 64fi
48 65
49if [[ -n ${WANT_AUTOCONF} ]] ; then 66if [[ -n ${WANT_AUTOCONF} ]] ; then
50 case ${WANT_AUTOCONF} in 67 case ${WANT_AUTOCONF} in
51 none) _autoconf_atom="" ;; # some packages don't require autoconf at all 68 none) _autoconf_atom="" ;; # some packages don't require autoconf at all
52 2.1) _autoconf_atom="=sys-devel/autoconf-${WANT_AUTOCONF}*" ;; 69 2.1) _autoconf_atom="=sys-devel/autoconf-${WANT_AUTOCONF}*" ;;
53 # if you change the latest version here, change also autotools_run_tool 70 # if you change the "latest" version here, change also autotools_env_setup
54 latest|2.5) _autoconf_atom=">=sys-devel/autoconf-2.61" ;; 71 latest|2.5) _autoconf_atom=">=sys-devel/autoconf-2.68" ;;
55 *) _autoconf_atom="INCORRECT-WANT_AUTOCONF-SETTING-IN-EBUILD" ;; 72 *) die "Invalid WANT_AUTOCONF value '${WANT_AUTOCONF}'" ;;
56 esac 73 esac
57 export WANT_AUTOCONF 74 export WANT_AUTOCONF
58fi 75fi
59 76
77_libtool_atom="sys-devel/libtool"
78if [[ -n ${WANT_LIBTOOL} ]] ; then
79 case ${WANT_LIBTOOL} in
80 none) _libtool_atom="" ;;
81 latest) ;;
82 *) die "Invalid WANT_LIBTOOL value '${WANT_LIBTOOL}'" ;;
83 esac
84 export WANT_LIBTOOL
85fi
86
60AUTOTOOLS_DEPEND="${_automake_atom} ${_autoconf_atom}" 87AUTOTOOLS_DEPEND="${_automake_atom} ${_autoconf_atom} ${_libtool_atom}"
61[[ ${CATEGORY}/${PN} != "sys-devel/libtool" ]] && AUTOTOOLS_DEPEND="${AUTOTOOLS_DEPEND} >=sys-devel/libtool-2.2.6b"
62RDEPEND="" 88RDEPEND=""
63 89
64# @ECLASS-VARIABLE: AUTOTOOLS_AUTO_DEPEND 90# @ECLASS-VARIABLE: AUTOTOOLS_AUTO_DEPEND
65# @DESCRIPTION: 91# @DESCRIPTION:
66# Set to 'no' to disable automatically adding to DEPEND. This lets 92# Set to 'no' to disable automatically adding to DEPEND. This lets
72fi 98fi
73 99
74unset _automake_atom _autoconf_atom 100unset _automake_atom _autoconf_atom
75 101
76# @ECLASS-VARIABLE: AM_OPTS 102# @ECLASS-VARIABLE: AM_OPTS
103# @DEFAULT_UNSET
77# @DESCRIPTION: 104# @DESCRIPTION:
78# Additional options to pass to automake during 105# Additional options to pass to automake during
79# eautoreconf call. 106# eautoreconf call.
80 107
108# @ECLASS-VARIABLE: AT_NOEACLOCAL
109# @DEFAULT_UNSET
110# @DESCRIPTION:
111# Don't run eaclocal command if set to 'yes',
112# useful when eaclocal needs to be ran with
113# particular options
114
115# @ECLASS-VARIABLE: AT_NOEAUTOCONF
116# @DEFAULT_UNSET
117# @DESCRIPTION:
118# Don't run eautoconf command if set to 'yes',
119# useful when eautoconf needs to be ran with
120# particular options
121
122# @ECLASS-VARIABLE: AT_NOEAUTOMAKE
123# @DEFAULT_UNSET
124# @DESCRIPTION:
125# Don't run eautomake command if set to 'yes',
126# useful when eautomake needs to be ran with
127# particular options
128
81# @ECLASS-VARIABLE: AT_NOELIBTOOLIZE 129# @ECLASS-VARIABLE: AT_NOELIBTOOLIZE
130# @DEFAULT_UNSET
82# @DESCRIPTION: 131# @DESCRIPTION:
83# Don't run elibtoolize command if set to 'yes', 132# Don't run elibtoolize command if set to 'yes',
84# useful when elibtoolize needs to be ran with 133# useful when elibtoolize needs to be ran with
85# particular options 134# particular options
86 135
87# XXX: M4DIR should be deprecated
88# @ECLASS-VARIABLE: AT_M4DIR 136# @ECLASS-VARIABLE: AT_M4DIR
89# @DESCRIPTION: 137# @DESCRIPTION:
90# Additional director(y|ies) aclocal should search 138# Additional director(y|ies) aclocal should search
91: ${AT_M4DIR:=${M4DIR}} 139: ${AT_M4DIR:=}
92AT_GNUCONF_UPDATE="no"
93 140
141# @ECLASS-VARIABLE: AT_SYS_M4DIR
142# @INTERNAL
143# @DESCRIPTION:
144# For system integrators, a list of additional aclocal search paths.
145# This variable gets eval-ed, so you can use variables in the definition
146# that may not be valid until eautoreconf & friends are run.
147: ${AT_SYS_M4DIR:=}
94 148
95# @FUNCTION: eautoreconf 149# @FUNCTION: eautoreconf
96# @DESCRIPTION: 150# @DESCRIPTION:
97# This function mimes the behavior of autoreconf, but uses the different 151# This function mimes the behavior of autoreconf, but uses the different
98# eauto* functions to run the tools. It doesn't accept parameters, but 152# eauto* functions to run the tools. It doesn't accept parameters, but
114 done 168 done
115 fi 169 fi
116 170
117 auxdir=$(autotools_get_auxdir) 171 auxdir=$(autotools_get_auxdir)
118 172
173 if [[ ${AT_NOEACLOCAL} != "yes" ]]; then
119 einfo "Running eautoreconf in '${PWD}' ..." 174 einfo "Running eautoreconf in '${PWD}' ..."
120 [[ -n ${auxdir} ]] && mkdir -p ${auxdir} 175 [[ -n ${auxdir} ]] && mkdir -p ${auxdir}
121 eaclocal 176 eaclocal
177 fi
122 [[ ${CHOST} == *-darwin* ]] && g=g 178 [[ ${CHOST} == *-darwin* ]] && g=g
123 if ${LIBTOOLIZE:-${g}libtoolize} -n --install >& /dev/null ; then 179 if ${LIBTOOLIZE:-${g}libtoolize} -n --install >& /dev/null ; then
124 _elibtoolize --copy --force --install 180 _elibtoolize --copy --force --install
125 else 181 else
126 _elibtoolize --copy --force 182 _elibtoolize --copy --force
127 fi 183 fi
128 eautoconf 184 [[ ${AT_NOEAUTOCONF} != "yes" ]] && eautoconf
129 eautoheader 185 [[ ${AT_NOEAUTOHEADER} != "yes" ]] && eautoheader
130 FROM_EAUTORECONF="yes" eautomake ${AM_OPTS} 186 [[ ${AT_NOEAUTOMAKE} != "yes" ]] && FROM_EAUTORECONF="yes" eautomake ${AM_OPTS}
131 187
132 [[ ${AT_NOELIBTOOLIZE} == "yes" ]] && return 0 188 [[ ${AT_NOELIBTOOLIZE} == "yes" ]] && return 0
133 189
134 # Call it here to prevent failures due to elibtoolize called _before_ 190 # Call it here to prevent failures due to elibtoolize called _before_
135 # eautoreconf. We set $S because elibtoolize runs on that #265319 191 # eautoreconf. We set $S because elibtoolize runs on that #265319
136 S=${PWD} elibtoolize 192 S=${PWD} elibtoolize --force
137 193
138 return 0 194 return 0
195}
196
197# @FUNCTION: eaclocal_amflags
198# @DESCRIPTION:
199# Extract the ACLOCAL_AMFLAGS value from the Makefile.am and try to handle
200# (most) of the crazy crap that people throw at us.
201eaclocal_amflags() {
202 local aclocal_opts amflags_file
203
204 for amflags_file in GNUmakefile.am Makefile.am GNUmakefile.in Makefile.in ; do
205 [[ -e ${amflags_file} ]] || continue
206 # setup the env in case the pkg does something crazy
207 # in their ACLOCAL_AMFLAGS. like run a shell script
208 # which turns around and runs autotools. #365401
209 # or split across multiple lines. #383525
210 autotools_env_setup
211 aclocal_opts=$(sed -n \
212 "/^ACLOCAL_AMFLAGS[[:space:]]*=/{ \
213 # match the first line
214 s:[^=]*=::p; \
215 # then gobble up all escaped lines
216 : nextline /\\\\$/{ n; p; b nextline; } \
217 }" ${amflags_file})
218 eval aclocal_opts=\""${aclocal_opts}"\"
219 break
220 done
221
222 echo ${aclocal_opts}
139} 223}
140 224
141# @FUNCTION: eaclocal 225# @FUNCTION: eaclocal
142# @DESCRIPTION: 226# @DESCRIPTION:
143# These functions runs the autotools using autotools_run_tool with the 227# These functions runs the autotools using autotools_run_tool with the
144# specified parametes. The name of the tool run is the same of the function 228# specified parametes. The name of the tool run is the same of the function
145# without e prefix. 229# without e prefix.
146# They also force installing the support files for safety. 230# They also force installing the support files for safety.
147# Respects AT_M4DIR for additional directories to search for macro's. 231# Respects AT_M4DIR for additional directories to search for macro's.
148eaclocal() { 232eaclocal() {
149 local aclocal_opts
150
151 local amflags_file
152 for amflags_file in GNUmakefile.am Makefile.am GNUmakefile.in Makefile.in ; do
153 [[ -e ${amflags_file} ]] || continue
154 aclocal_opts=$(sed -n '/^ACLOCAL_AMFLAGS[[:space:]]*=/s:[^=]*=::p' ${amflags_file})
155 eval aclocal_opts=\"${aclocal_opts}\"
156 break
157 done
158
159 if [[ -n ${AT_M4DIR} ]] ; then
160 for x in ${AT_M4DIR} ; do
161 case "${x}" in
162 "-I")
163 # We handle it below
164 ;;
165 *)
166 [[ ! -d ${x} ]] && ewarn "eaclocal: '${x}' does not exist"
167 aclocal_opts="${aclocal_opts} -I ${x}"
168 ;;
169 esac
170 done
171 fi
172
173 [[ ! -f aclocal.m4 || -n $(grep -e 'generated.*by aclocal' aclocal.m4) ]] && \ 233 [[ ! -f aclocal.m4 || -n $(grep -e 'generated.*by aclocal' aclocal.m4) ]] && \
174 autotools_run_tool aclocal "$@" ${aclocal_opts} 234 autotools_run_tool --at-m4flags aclocal "$@" $(eaclocal_amflags)
175} 235}
176 236
177# @FUNCTION: _elibtoolize 237# @FUNCTION: _elibtoolize
178# @DESCRIPTION: 238# @DESCRIPTION:
179# Runs libtoolize. Note the '_' prefix .. to not collide with elibtoolize() from 239# Runs libtoolize. Note the '_' prefix .. to not collide with elibtoolize() from
198# @DESCRIPTION: 258# @DESCRIPTION:
199# Runs autoheader. 259# Runs autoheader.
200eautoheader() { 260eautoheader() {
201 # Check if we should run autoheader 261 # Check if we should run autoheader
202 [[ -n $(autotools_check_macro "AC_CONFIG_HEADERS") ]] || return 0 262 [[ -n $(autotools_check_macro "AC_CONFIG_HEADERS") ]] || return 0
203 NO_FAIL=1 autotools_run_tool autoheader "$@" 263 autotools_run_tool --at-no-fail --at-m4flags autoheader "$@"
204} 264}
205 265
206# @FUNCTION: eautoconf 266# @FUNCTION: eautoconf
207# @DESCRIPTION: 267# @DESCRIPTION:
208# Runs autoconf. 268# Runs autoconf.
212 eerror "No configure.{ac,in} present in '${PWD}'!" 272 eerror "No configure.{ac,in} present in '${PWD}'!"
213 echo 273 echo
214 die "No configure.{ac,in} present!" 274 die "No configure.{ac,in} present!"
215 fi 275 fi
216 276
217 autotools_run_tool autoconf "$@" 277 autotools_run_tool --at-m4flags autoconf "$@"
218} 278}
219 279
220# @FUNCTION: eautomake 280# @FUNCTION: eautomake
221# @DESCRIPTION: 281# @DESCRIPTION:
222# Runs automake. 282# Runs automake.
224 local extra_opts 284 local extra_opts
225 local makefile_name 285 local makefile_name
226 286
227 # Run automake if: 287 # Run automake if:
228 # - a Makefile.am type file exists 288 # - a Makefile.am type file exists
229 # - a Makefile.in type file exists and the configure
230 # script is using the AM_INIT_AUTOMAKE directive 289 # - the configure script is using the AM_INIT_AUTOMAKE directive
231 for makefile_name in {GNUmakefile,{M,m}akefile}.{am,in} "" ; do 290 for makefile_name in {GNUmakefile,{M,m}akefile}.am "" ; do
232 [[ -f ${makefile_name} ]] && break 291 [[ -f ${makefile_name} ]] && break
233 done 292 done
234 [[ -z ${makefile_name} ]] && return 0
235 293
236 if [[ ${makefile_name} == *.in ]] ; then 294 if [[ -z ${makefile_name} ]] ; then
237 if ! grep -qs AM_INIT_AUTOMAKE configure.?? ; then 295 if ! grep -qs AM_INIT_AUTOMAKE configure.?? ; then
238 return 0 296 return 0
239 fi 297 fi
240 298
241 elif [[ -z ${FROM_EAUTORECONF} && -f ${makefile_name%.am}.in ]]; then 299 elif [[ -z ${FROM_EAUTORECONF} && -f ${makefile_name%.am}.in ]]; then
253 eautoreconf 311 eautoreconf
254 return 0 312 return 0
255 fi 313 fi
256 fi 314 fi
257 315
258 [[ -f INSTALL && -f AUTHORS && -f ChangeLog && -f NEWS ]] \ 316 [[ -f INSTALL && -f AUTHORS && -f ChangeLog && -f NEWS && -f README ]] \
259 || extra_opts="${extra_opts} --foreign" 317 || extra_opts="${extra_opts} --foreign"
260 318
261 # --force-missing seems not to be recognized by some flavours of automake 319 # --force-missing seems not to be recognized by some flavours of automake
262 autotools_run_tool automake --add-missing --copy ${extra_opts} "$@" 320 autotools_run_tool automake --add-missing --copy ${extra_opts} "$@"
263} 321}
267# Runs autopoint (from the gettext package). 325# Runs autopoint (from the gettext package).
268eautopoint() { 326eautopoint() {
269 autotools_run_tool autopoint "$@" 327 autotools_run_tool autopoint "$@"
270} 328}
271 329
330# @FUNCTION: config_rpath_update
331# @USAGE: [destination]
332# @DESCRIPTION:
333# Some packages utilize the config.rpath helper script, but don't
334# use gettext directly. So we have to copy it in manually since
335# we can't let `autopoint` do it for us.
336config_rpath_update() {
337 local dst src=$(type -P gettext | sed 's:bin/gettext:share/gettext/config.rpath:')
338
339 [[ $# -eq 0 ]] && set -- $(find -name config.rpath)
340 [[ $# -eq 0 ]] && return 0
341
342 einfo "Updating all config.rpath files"
343 for dst in "$@" ; do
344 einfo " ${dst}"
345 cp "${src}" "${dst}" || die
346 done
347}
348
272# Internal function to run an autotools' tool 349# Internal function to run an autotools' tool
350autotools_env_setup() {
351 # We do the "latest" → version switch here because it solves
352 # possible order problems, see bug #270010 as an example.
353 if [[ ${WANT_AUTOMAKE} == "latest" ]]; then
354 # has_version respects ROOT, but in this case, we don't want it to,
355 # thus "ROOT=/" prefix:
356 ROOT=/ has_version "=sys-devel/automake-$(get_version_component_range 1-2 ${_LATEST_AUTOMAKE})*" && export WANT_AUTOMAKE="$(get_version_component_range 1-2 ${_LATEST_AUTOMAKE})"
357
358 [[ ${WANT_AUTOMAKE} == "latest" ]] && \
359 die "Cannot find the latest automake! Tried ${_LATEST_AUTOMAKE}"
360 fi
361 [[ ${WANT_AUTOCONF} == "latest" ]] && export WANT_AUTOCONF=2.5
362}
273autotools_run_tool() { 363autotools_run_tool() {
364 # Process our own internal flags first
365 local autofail=true m4flags=false
366 while [[ -n $1 ]] ; do
367 case $1 in
368 --at-no-fail) autofail=false;;
369 --at-m4flags) m4flags=true;;
370 # whatever is left goes to the actual tool
371 *) break;;
372 esac
373 shift
374 done
375
274 if [[ ${EBUILD_PHASE} != "unpack" && ${EBUILD_PHASE} != "prepare" ]]; then 376 if [[ ${EBUILD_PHASE} != "unpack" && ${EBUILD_PHASE} != "prepare" ]]; then
275 ewarn "QA Warning: running $1 in ${EBUILD_PHASE} phase" 377 ewarn "QA Warning: running $1 in ${EBUILD_PHASE} phase"
276 fi 378 fi
277 379
278 # We do the “latest” → version switch here because it solves 380 autotools_env_setup
279 # possible order problems, see bug #270010 as an example.
280 if [[ ${WANT_AUTOMAKE} == "latest" ]]; then
281 local pv
282 for pv in ${_LATEST_AUTOMAKE} ; do
283 # has_version respects ROOT, but in this case, we don't want it to,
284 # thus "ROOT=/" prefix:
285 ROOT=/ has_version "=sys-devel/automake-${pv}*" && export WANT_AUTOMAKE="$pv"
286 done
287 [[ ${WANT_AUTOMAKE} == "latest" ]] && \
288 die "Cannot find the latest automake! Tried ${_LATEST_AUTOMAKE}"
289 fi
290 [[ ${WANT_AUTOCONF} == "latest" ]] && export WANT_AUTOCONF=2.5
291 381
292 local STDERR_TARGET="${T}/$1.out" 382 local STDERR_TARGET="${T}/$1.out"
293 # most of the time, there will only be one run, but if there are 383 # most of the time, there will only be one run, but if there are
294 # more, make sure we get unique log filenames 384 # more, make sure we get unique log filenames
295 if [[ -e ${STDERR_TARGET} ]] ; then 385 if [[ -e ${STDERR_TARGET} ]] ; then
386 local i=1
387 while :; do
296 STDERR_TARGET="${T}/$1-$$.out" 388 STDERR_TARGET="${T}/$1-${i}.out"
389 [[ -e ${STDERR_TARGET} ]] || break
390 : $(( i++ ))
391 done
392 fi
393
394 if ${m4flags} ; then
395 set -- "${1}" $(autotools_m4dir_include) "${@:2}" $(autotools_m4sysdir_include)
297 fi 396 fi
298 397
299 printf "***** $1 *****\n***** PWD: ${PWD}\n***** $*\n\n" > "${STDERR_TARGET}" 398 printf "***** $1 *****\n***** PWD: ${PWD}\n***** $*\n\n" > "${STDERR_TARGET}"
300 399
301 ebegin "Running $@" 400 ebegin "Running $@"
302 "$@" >> "${STDERR_TARGET}" 2>&1 401 "$@" >> "${STDERR_TARGET}" 2>&1
303 eend $? 402 if ! eend $? && ${autofail} ; then
304
305 if [[ $? != 0 && ${NO_FAIL} != 1 ]] ; then
306 echo 403 echo
307 eerror "Failed Running $1 !" 404 eerror "Failed Running $1 !"
308 eerror 405 eerror
309 eerror "Include in your bugreport the contents of:" 406 eerror "Include in your bugreport the contents of:"
310 eerror 407 eerror
317# Internal function to check for support 414# Internal function to check for support
318autotools_check_macro() { 415autotools_check_macro() {
319 [[ -f configure.ac || -f configure.in ]] || return 0 416 [[ -f configure.ac || -f configure.in ]] || return 0
320 local macro 417 local macro
321 for macro ; do 418 for macro ; do
322 WANT_AUTOCONF="2.5" autoconf --trace="${macro}" 2>/dev/null 419 WANT_AUTOCONF="2.5" autoconf $(autotools_m4dir_include) --trace="${macro}" 2>/dev/null
323 done 420 done
324 return 0 421 return 0
325} 422}
326 423
424# Internal function to look for a macro and extract its value
425autotools_check_macro_val() {
426 local macro=$1 scan_out
427
428 autotools_check_macro "${macro}" | \
429 gawk -v macro="${macro}" \
430 '($0 !~ /^[[:space:]]*(#|dnl)/) {
431 if (match($0, macro ":(.*)$", res))
432 print res[1]
433 }' | uniq
434
435 return 0
436}
437
327# Internal function to get additional subdirs to configure 438# Internal function to get additional subdirs to configure
328autotools_get_subdirs() { 439autotools_get_subdirs() { autotools_check_macro_val AC_CONFIG_SUBDIRS ; }
329 local subdirs_scan_out 440autotools_get_auxdir() { autotools_check_macro_val AC_CONFIG_AUX_DIR ; }
330 441
331 subdirs_scan_out=$(autotools_check_macro "AC_CONFIG_SUBDIRS") 442_autotools_m4dir_include() {
332 [[ -n ${subdirs_scan_out} ]] || return 0 443 local x include_opts
333 444
334 echo "${subdirs_scan_out}" | gawk \ 445 for x in "$@" ; do
335 '($0 !~ /^[[:space:]]*(#|dnl)/) { 446 case ${x} in
336 if (match($0, /AC_CONFIG_SUBDIRS:(.*)$/, res)) 447 # We handle it below
337 print res[1] 448 -I) ;;
338 }' | uniq 449 *)
450 [[ ! -d ${x} ]] && ewarn "autotools.eclass: '${x}' does not exist"
451 include_opts+=" -I ${x}"
452 ;;
453 esac
454 done
339 455
340 return 0 456 echo ${include_opts}
341} 457}
458autotools_m4dir_include() { _autotools_m4dir_include ${AT_M4DIR} ; }
459autotools_m4sysdir_include() { _autotools_m4dir_include $(eval echo ${AT_SYS_M4DIR}) ; }
342 460
343autotools_get_auxdir() { 461fi
344 local auxdir_scan_out
345
346 auxdir_scan_out=$(autotools_check_macro "AC_CONFIG_AUX_DIR")
347 [[ -n ${auxdir_scan_out} ]] || return 0
348
349 echo ${auxdir_scan_out} | gawk \
350 '($0 !~ /^[[:space:]]*(#|dnl)/) {
351 if (match($0, /AC_CONFIG_AUX_DIR:(.*)$/, res))
352 print res[1]
353 }' | uniq
354
355 return 0
356}

Legend:
Removed from v.1.99  
changed lines
  Added in v.1.127

  ViewVC Help
Powered by ViewVC 1.1.20